<script>
import { GlLabel, GlLink, GlButton } from '@gitlab/ui'

export default {
  name: 'LazyMdCardValue',

  components: { GlLabel, GlLink, GlButton },

  props: {
    item: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      label: this.item.label,
      value: this.item.value,
      type: this.item.type,
      props: this.item.props,
      on: this.item.on,
    }
  },

  methods: {
    hasNoWhiteSpace(value) {
      return !/\s/.test(value)
    },
  },
}
</script>

<template>
  <div class="items-center py-2.5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-4">
    <dt class="text-sm font-medium text-gray-500">{{ label }}</dt>
    <dd class="m-0 sm:col-span-2">
      <span v-if="!value" class="text-gray-400">-</span>

      <gl-link v-else-if="type === 'GlLink'" target="_blank" v-bind="props">
        {{ value }}
      </gl-link>

      <gl-button v-else-if="type === 'GlButton'" v-bind="props" v-on="on">{{
        value
      }}</gl-button>

      <gl-label
        v-else-if="type === 'GlLabel'"
        :title="value"
        v-bind="props"
        scoped
      />

      <template v-else-if="type === 'GlLabelList' && Array.isArray(value)">
        <span
          v-for="listItem in value"
          :key="`label-${listItem}`"
          class="label-list"
        >
          <gl-label :title="listItem" v-bind="props" />
        </span>
      </template>

      <div v-else-if="type === 'object'" class="overflow-x-auto text-sm">
        <lazy-md-card-object
          v-for="[optionLabel, optionValue] in value"
          :key="optionValue.toString()"
          :label="optionLabel"
          :value="optionValue"
        />
      </div>

      <!-- eslint-disable vue/no-v-html -->
      <div
        v-else-if="type === 'value'"
        class="text-sm"
        :class="{
          'font-mono': hasNoWhiteSpace(value),
          'italic': !hasNoWhiteSpace(value),
        }"
        v-html="value"
      />
      <!-- eslint-enable vue/no-v-html -->

      <div v-else class="m-0 text-sm text-gray-900">{{ value }}</div>
    </dd>
  </div>
</template>
